/* DerivateView */

#import <Cocoa/Cocoa.h>
//#import "funciones.h"

// Define Funciones
#define SIN  0 
#define COS  1 
#define TAN  2 
#define EXP  3 
#define LOG  4 
#define SINH 5 
#define COSH 6 
#define TANH 7 

// Define Tipo Graficas 
#define FUNCTION 100
#define DERIVATE 101

// Define Labels
#define AXES           200
#define LABEL_AXES     201 
#define LABEL_FUNCTION 202

// Define escalas de las coordenadas X-Y 
#define XMARK 20.0 
#define YMARK 20.8

#define PI 3.1416

typedef double (*doFunctions)(double); 

@interface DerivateView : NSView
{
    IBOutlet id acolor;		// Axes color
    IBOutlet id bcolor;		// Background color 
    IBOutlet id dcolor;		// Derivate function color 
    IBOutlet id fcolor;		// Function color 
    IBOutlet id lcolor;		// Label color 

    NSBezierPath *bpaxes; 
    NSBezierPath *bpfun;
    NSBezierPath *bpder;

    BOOL clean; 
    BOOL axes; 
    BOOL laxes;
    BOOL lfun; 
    BOOL gfun; 
    BOOL gder; 
    BOOL ard; 
    int  tfunction; 
    double  xmin; 
    double  xmax; 
    int  nsteps; 
}

- (id)initWithFrame:(NSRect)frameRect; 
- (void)awakeFromNib; 
- (void)dealloc;

- (void)displayLabelWithRect:(NSRect)rect;
- (void)displayLabelFunction; 

- (IBAction)clean:(id)sender;
- (IBAction)draw:(id)sender;
- (IBAction)setFunction:(id)sender;
- (IBAction)setGraphic:(id)sender;
- (IBAction)setLabels:(id)sender;
- (IBAction)setColors:(id)sender;
- (IBAction)setAutomaticRedraw:(id)sender;


- (NSPoint)function: (float)x; 
- (NSPoint)derivate: (float)t; 
@end
